"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LoadingState = exports.Default = exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _index = require("./index");

var _FakeProvider = require("./FakeProvider");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _default = {
  title: 'UI/App',
  component: _index.Root
};
exports["default"] = _default;

var Default = function Default() {
  return _react["default"].createElement(_index.Root, {
    provider: new _FakeProvider.FakeProvider()
  });
};

exports.Default = Default;
Default.displayName = "Default";

var LoadingState = function LoadingState() {
  return _react["default"].createElement(_index.Root, {
    provider: new _FakeProvider.PrettyFakeProvider()
  });
};

exports.LoadingState = LoadingState;
LoadingState.displayName = "LoadingState";