"use strict";

require("core-js/modules/es.symbol");

require("core-js/modules/es.symbol.description");

require("core-js/modules/es.symbol.iterator");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.object.create");

require("core-js/modules/es.object.define-property");

require("core-js/modules/es.object.get-prototype-of");

require("core-js/modules/es.object.set-prototype-of");

require("core-js/modules/es.object.to-string");

require("core-js/modules/es.string.iterator");

require("core-js/modules/web.dom-collections.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PrettyFakeProvider = exports.Centered = exports.FakeProvider = void 0;

var _react = _interopRequireDefault(require("react"));

var _theming = require("@storybook/theming");

var _addons = require("@storybook/addons");

var _provider = _interopRequireDefault(require("./provider"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var _ref = /*#__PURE__*/_react["default"].createElement("div", null, "This is from a 'renderPreview' call from FakeProvider");

var FakeProvider = /*#__PURE__*/function (_Provider) {
  _inherits(FakeProvider, _Provider);

  function FakeProvider() {
    var _this;

    _classCallCheck(this, FakeProvider);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(FakeProvider).call(this)); // @ts-ignore

    _this.addons = _addons.addons; // @ts-ignore

    _this.channel = {
      on: function on() {},
      off: function off() {},
      emit: function emit() {},
      addPeerListener: function addPeerListener() {}
    };
    return _this;
  } // @ts-ignore


  _createClass(FakeProvider, [{
    key: "getElements",
    value: function getElements(type) {
      return _addons.addons.getElements(type);
    }
  }, {
    key: "renderPreview",
    value: function renderPreview() {
      return _ref;
    } // @ts-ignore

  }, {
    key: "handleAPI",
    value: function handleAPI(api) {
      _addons.addons.loadAddons(api);
    } // @ts-ignore

  }, {
    key: "getConfig",
    value: function getConfig() {
      return {};
    }
  }]);

  return FakeProvider;
}(_provider["default"]);

exports.FakeProvider = FakeProvider;

var Centered = _theming.styled.div({
  width: '100vw',
  height: '100vh',
  display: 'flex',
  justifyContent: 'center',
  alignItems: 'center',
  flexDirection: 'column'
});

exports.Centered = Centered;

var _ref2 = /*#__PURE__*/_react["default"].createElement("hr", null);

var PrettyFakeProvider = /*#__PURE__*/function (_FakeProvider) {
  _inherits(PrettyFakeProvider, _FakeProvider);

  function PrettyFakeProvider() {
    _classCallCheck(this, PrettyFakeProvider);

    return _possibleConstructorReturn(this, _getPrototypeOf(PrettyFakeProvider).apply(this, arguments));
  }

  _createClass(PrettyFakeProvider, [{
    key: "renderPreview",
    value: function renderPreview() {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _react["default"].createElement(Centered, null, "This is from a 'renderPreview' call from FakeProvider", _ref2, "'renderPreview' was called with:", _react["default"].createElement("pre", null, JSON.stringify(args, null, 2)));
    }
  }]);

  return PrettyFakeProvider;
}(FakeProvider);

exports.PrettyFakeProvider = PrettyFakeProvider;