import React, { Component, CSSProperties, IframeHTMLAttributes } from 'react';
export interface IFrameProps {
    id: string;
    title: string;
    src: string;
    allowFullScreen: boolean;
    scale: number;
}
export declare class IFrame extends Component<IFrameProps & IframeHTMLAttributes<HTMLIFrameElement>> {
    iframe: HTMLIFrameElement;
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: IFrameProps): boolean;
    setIframeBodyStyle(style: CSSProperties): CSSStyleDeclaration & React.CSSProperties;
    render(): JSX.Element;
}
