"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.missingStory = exports.workingStory = exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _iframe = require("./iframe");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _default = {
  component: _iframe.IFrame,
  title: 'UI/Iframe'
};
exports["default"] = _default;
var style = {
  width: '500px',
  height: '500px',
  border: '2px solid hotpink',
  position: 'relative'
};

var _ref = /*#__PURE__*/_react["default"].createElement(_iframe.IFrame, {
  id: "iframe",
  title: "Missing",
  src: "/iframe.html?id=ui-panel--default",
  allowFullScreen: true,
  style: style,
  scale: 1.0
});

var workingStory = function workingStory() {
  return _ref;
};

exports.workingStory = workingStory;
workingStory.displayName = "workingStory";

var _ref2 = /*#__PURE__*/_react["default"].createElement(_iframe.IFrame, {
  id: "iframe",
  title: "Missing",
  src: "/iframe.html?id=missing",
  allowFullScreen: true,
  style: style,
  scale: 1.0
});

var missingStory = function missingStory() {
  return _ref2;
};

exports.missingStory = missingStory;
missingStory.displayName = "missingStory";