"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.previewProps = void 0;

var _addons = require("@storybook/addons");

var previewProps = {
  id: 'string',
  api: {
    on: function on() {},
    emit: function emit() {},
    off: function off() {},
    getElements: function (type) {
      return type === _addons.types.TAB ? [{
        id: 'notes',
        type: _addons.types.TAB,
        title: 'Notes',
        route: function route(_ref) {
          var storyId = _ref.storyId;
          return "/info/".concat(storyId);
        },
        match: function match(_ref2) {
          var viewMode = _ref2.viewMode;
          return viewMode === 'info';
        },
        render: function render() {
          return null;
        }
      }] : [];
    }
  },
  storyId: 'string',
  path: 'string',
  viewMode: 'story',
  location: {},
  baseUrl: 'http://example.com',
  queryParams: {},
  options: {
    isFullscreen: false,
    isToolshown: true
  },
  withLoader: false,
  docsOnly: false,
  description: '',
  parameters: {}
};
exports.previewProps = previewProps;