import { FunctionComponent } from 'react';
import { StoriesHash } from '@storybook/api';
export declare const viewMode: (currentViewMode: string, isDocsOnly: boolean, parameters?: {
    viewMode?: string;
}) => string;
export declare const Link: FunctionComponent<{
    id: string;
    name: string;
    isLeaf: boolean;
    prefix: string;
    onKeyUp: Function;
    onClick: Function;
    childIds: string[] | null;
    isExpanded: boolean;
    isComponent: boolean;
    parameters: Record<string, any>;
}>;
export interface StoriesProps {
    isLoading: boolean;
    stories: StoriesHash;
    storyId?: undefined | string;
    className?: undefined | string;
}
declare const SidebarStories: FunctionComponent<StoriesProps>;
export default SidebarStories;
