import { ComponentProps } from 'react';
import { Icons } from '@storybook/components';
import { API } from '@storybook/api';
export interface ListItemIconProps {
    icon?: ComponentProps<typeof Icons>['icon'];
    imgSrc?: string;
}
export declare const MenuItemIcon: ({ icon, imgSrc }: ListItemIconProps) => JSX.Element;
export declare const useMenu: (api: API, isFullscreen: boolean, showPanel: boolean, showNav: boolean, enableShortcuts: boolean) => {
    id: string;
    title: string;
    onClick: () => void;
    right: any;
    left: string | JSX.Element;
}[];
