import React from 'react';
import { DesktopProps } from './desktop';
declare const _default: {
    title: string;
    component: React.NamedExoticComponent<DesktopProps> & {
        displayName: string;
    };
    decorators: ((...args: any) => any)[];
};
export default _default;
export declare const Default: ({ props }: {
    props: DesktopProps;
}) => JSX.Element;
export declare const NoAddons: ({ props }: {
    props: DesktopProps;
}) => JSX.Element;
export declare const NoSidebar: ({ props }: {
    props: DesktopProps;
}) => JSX.Element;
export declare const NoPanel: ({ props }: {
    props: DesktopProps;
}) => JSX.Element;
export declare const BottomPanel: ({ props }: {
    props: DesktopProps;
}) => JSX.Element;
export declare const Fullscreen: ({ props }: {
    props: DesktopProps;
}) => JSX.Element;
export declare const NoPanelNoSidebar: ({ props }: {
    props: DesktopProps;
}) => JSX.Element;
export declare const Page: ({ props }: {
    props: DesktopProps;
}) => JSX.Element;
